--[[
	-------------------------------------------------------------------------------
									识图2.0 LUA 安卓接口
	-------------------------------------------------------------------------------
	
	/**
	 * 敬告使用者
	 *
	 * 网站SDK页面提供的接口、实例文件均为第三方开发，非识图开发，因技术原因，识图平台未进行代码审查，亦不能确定代码的功能作用，请接入的开发者审查代码后调用。如实例中包含恶意代码或针对某网站、软件的攻击行为，请联系平台删除链接。
	 *
	 * 识别平台仅为残障人士以及有需要的个人和企业提供图像识别和图像识别分类服务，平台仅仅被动接受开发者传入的图像返回图像中的文字或结果信息，不参与破解，不为恶意软件提供帮助，不针对任何网站或个人。
	 * 请勿利用识别做违反国家法律法规的行为，否则强制停止使用，不予退费，将依法向有关部门递交您的个人资料！
	 * 违法软件是指的是包括但不限于以下用途的软件：
	 * 1、破解、入侵系统，或正常登录但超越授权范围获取信息。
	 * 2、赌博
	 * 3、薅羊毛
	 * 4、批量登录、批量注册、批量支付
	 * 5、游戏外挂、游戏辅助
	 * 6、超越访问频率限制
	 * 7、批量盗取公民个人信息，获取手机号、身份证等隐私信息
	 *
	 */

--]]


--
	---------------------------------- 内部函数 ----------------------------------
--

function print(...)
	LuaAuxLib.TracePrint(":" .. ...)
end



--读取文件二进制
function ReadFileByte(file)
	local f = io.open(file,"rb")
	local retbyte = f:read("*all")
	f:close()
	return retbyte
end

--读取文件转换成base64编码
function ReadFileBase(path)
	local iRet, sRet = pcall(function()
		local str = ReadFileByte(path)
		local bor, band, lshift, rshift = bit32.bor, bit32.band, bit32.lshift, bit32.rshift
		cTable = {
			'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
			'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
			'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
			'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/',
		}
		local RetTbl = {}
		local a1, a2, a3, b1, b2, b3, b4
		local cProc = math.floor((str:len() / 3)) * 3
		local ii = 0
		-- 编码
		for i=1, cProc, 3 do
			ii = ii + 1
			a1 = str:byte(i)
			a2 = str:byte(i + 1)
			a3 = str:byte(i + 2)
			b1 = rshift(a1, 2)		
			b2 = band(bor(lshift(a1, 4), rshift(a2, 4)), 0x3F)
			b3 = band(bor(lshift(a2, 2), rshift(a3, 6)), 0x3F)
			b4 = band(a3, 0x3F)
			RetTbl[ii] = cTable[b1+1] .. cTable[b2+1] .. cTable[b3+1] .. cTable[b4+1]
		end
		-- 补充计算
		ii = ii + 1
		if (str:len() % 3) == 1 then
			a1 = str:byte(cProc + 1)
			b1 = rshift(band(a1, 0xFC), 2)
			b2 = lshift(band(a1, 0x03),4)
			RetTbl[ii] = cTable[b1+1] .. cTable[b2+1] .. "=="
		elseif (str:len() % 3) == 2 then
			a1 = str:byte(cProc + 1)
			a2 = str:byte(cProc + 2)
			b1 = rshift(band(a1, 0xFC), 2)
			b2 = bor(lshift(band(a1, 0x03), 4), rshift(band(a2, 0xF0), 4))
			b3 = lshift(band(a2, 0x0F), 2)
			RetTbl[ii] = cTable[b1+1] .. cTable[b2+1] .. cTable[b3+1] .. "="
		end
		return table.concat(RetTbl)
	end)
	if iRet == true then
		return sRet
	else
		return ""
	end
end 

-- PostHTTP
function PostHttp(url,heard, t)
	return LuaAuxLib.URL_OperationPost(url,heard, t)
end
--
	---------------------------------- 识图接口 ----------------------------------
--


--发送图片
function QMPlugin.tt_SendVerCode(user, pwd, filepath, tpe, tyename, angle,remark,filepathback,content,title_image,softid)
	local PostHost = "http://api.ttshitu.com/predict"
	--添加数据到table
	local rettable = {}
	local formtable = {
		["username"]			= user,
		["password"] 			= pwd,
		["image"] 		= ReadFileBase(filepath),
		["typeid"] 			= tpe,
		["typename"] 			= tyename,
		["angle"] 			= angle,
		["remark"] 			= remark,
		["imageback"] 			= ReadFileBase(filepathback),
		["content"] 			= content,
		["title_image"] 			= ReadFileBase(title_image),
		["softid"] 			= softid
		
	}
	--table转json
	local formjson = LuaAuxLib.Encode_GetJsonLib():encode(formtable)
	--提交信息
	local retjson = PostHttp(PostHost,formjson, 120)	
    return retjson
end





